 Option Explicit
'========================================================================================
'Module Title: Pin_I_O_R2.Bas
'========================================================================================
'Author: Don Kinzer  - routines were modified for a ZX-40  by ZbasicAndy
'========================================================================================
'Date:
'========================================================================================
'Operating System: XP
'========================================================================================
'ZBasic IDE Version: 1.1.1 / ZBasic Compiler version 1.24 / ZX-40 Firmware 1.2 / ZLoad v1.1.4
'========================================================================================
'Target: ZX-40x
'========================================================================================
'Hardware: "Multi-Z CPU" 
'Main/Support Modules Needed: Multi-Z CPU 1.bas - "sub main" basic module
'                             ComSupport_R4.bas - for basic serial communications subroutines. 
'
'========================================================================================
'Comport used: Comports 3,4 on ZX-40x  
'========================================================================================
'Bugs fixes and updates:
'
'
'
'
'
'
'
'
'========================================================================================
'Module Description: 
'
'=========================================================================================
'
'
'=========================================================================================
'Program Definitions:
'=========================================================================================

'=========================================================================================
'Constants
'[Public | Private] Const <name> As <type> = <value> (default private)
'=========================================================================================



'=========================================================================================
'Function Declarations: For ZX-40x only! 
'=========================================================================================
'=========
' PinState
'=========
' Determine the current state of a ZX-40 output pin.  If an invalid pin number
' is passed, zero is returned.  If the pin number of an input is passed,
' the result is meaningless.
'
Private Function PinState(ByVal pin as Byte) as Byte
	Select Case pin
	Case 1 To 8   'Port B
		 PinState = GetBit(Register.PortB, pin - 1)
	Case 14 To 21 'Port D
		 PinState = GetBit(Register.PortD, pin - 14)
	Case 22 To 29 'Port C
		 PinState = GetBit(Register.PortC, pin - 22)
	Case 33 to 40 'Port A
	     PinState = GetBit(Register.PortA, 40  - pin)
	Case Else
		PinState = 0
	End Select
End Function
'
'====================================================================================
'=============
'PinIsOutput
'=============
' Determine if a given ZX-40x pin is an output.  If a valid pin is passed
' and that pin is an output, 1 is returned otherwise zero is returned.
'
Private Function PinIsOutput(ByVal pin as Byte) as Byte
	Select Case pin
	Case 1 To 8 'Port B
		 PinIsOutput = GetBit(Register.DDRB, pin - 1)
	Case 14 To 21 'Port D
		 PinIsOutput = GetBit(Register.DDRD, pin - 14)
	Case 22 To 29 ' Port C
		 PinIsOutput = GetBit(Register.DDRC, pin - 22)
	Case 33 to 40 ' Port A - port is reversed!
	     PinIsOutput = GetBit(Register.DDRA, 40  - pin)
	Case Else
		PinIsOutput = 0
	End Select
End Function
'======================================================================================

'======================================================================================
'Subroutines - Generic for ZX-40
'======================================================================================
'=========
'TogglePin
'=========
'
' Given a ZX-40 pin number, if it is an output, the output state is
' set to the opposite state.  If the an invalid pin or an input pin is
' passed, no action is taken.
'
Public Sub TogglePin(ByVal pin as Byte)
	If (PinIsOutput(pin) <> 0) Then
		Call PutPin(pin, PinState(pin) Xor 1)
	End If
End Sub

