Option Explicit            'default (OFF) -implicit variable definition not used
Option Base 0              'arrays start with 0 not 1!
'
'========================================================================================
'Module Title: Time_Date_R2.Bas
'========================================================================================
'Author: ZbasicAndy
'========================================================================================
'Date:
'========================================================================================
'Operating System: XP
'========================================================================================
'ZBasic IDE Version: 1.1 / ZBasic Compiler version 1.2 / ZX-40 Firmware 1.2 / ZLoad v1.1.3
'========================================================================================
'Target: ZX-40
'========================================================================================
'Hardware: Super Comm Z R1 (4 [4 software serial & 1 Hardware] RS232 port ZX-40 PCB)
'Main/Support Modules Needed: ComSupport_R1.bas - for basic serial communications subroutines. 
'                             Super_Comm_Z_R1.bas - "sub main" basic module
'========================================================================================
'Comport used: None
'========================================================================================
'Bugs fixes and updates:
'
'
'
'
'
'
'
'
'========================================================================================
'Module Description:
'
'
'
'
'=========================================================================================
'
'
'=========================================================================================
'Program Definitions:
'=========================================================================================

'=====================================================================
'Constants
'[Public | Private] Const <name> As <type> = <value> (default private)
'=====================================================================
' Port Constants for all ports
'-----------------------------
' Do not modify!
Private Const Port3 as byte = 3           
Private Const Port4 as byte = 4
'Private Const Port5 as byte = 5
'Private Const Port6 as byte = 6
'-----------------------------

'=====================================================================
'Variables
'{Public | Private | Dim} <name> As <type> (default private)
'=====================================================================

 Public Year as integer
 Public Month as byte
 Public Day as byte
 Public Hour as byte
 Public Minute as byte
 Public Seconds as single
 
 Public Global_Local_Time as string
 Public Global_Local_Date as string

'=========================================================================================
'Functions
'=========================================================================================
'


'=========================================================================================
'Subroutines
'=========================================================================================


Public Sub Set_Time_Date()
'On download do not retreive time/date from ram and send PutTimeStamp parameters to controller
'On reset retrieve variables from ram
if ((firsttime()) = False) then 'On download skip
	Hour = RamPeek(&H800)
	Minute = RamPeek(&H801)
	Day = RamPeek(&H802)
	Month = RamPeek(&H803)
	Year = Cint(RamPeekWord(&H804))
	Seconds = 0.0
'write ram variables back to RTC 

Call PutTimeStamp(Year, Month, Day, Hour, Minute, Seconds)

'debug.print "Hour = " ; cstr(hour)
'debug.print "Minute = " ; cstr(minute)
'debug.print "Day = " ; cstr(day)
'debug.print "Month = " ; cstr(month)
'debug.print "year = " ; cstr(year)
Else
'On download set/put these date/time variables to RTC
Call PutTimeStamp(2006, 06, 15, 10, 27, 0.0) '<----- Set date/time(military) for downloading
End if
End Sub
'=========================================================================================
Public sub Display_Time_Date_BB()
dim BB_Message as string
dim Date_Time_Temp as string
dim DOW as byte
dim DOW_str as string
dim min_str as string
dim am_pm as string
dim Mon_Str as string
dim hour_str as string
static CID_Counter as long
dim hour_byte as byte
dim min_byte as byte
hour_str = ""
dim value as single
dim flag as boolean
dim temp_str as string
dim IR_trigger as byte

'read date/time
Call GetTimestamp(Year, Month, Day, Hour, Minute, Seconds)

DOW = GetDayOfWeek()
Select Case DOW
  Case 1
   DOW_Str = "Sun"
  Case 2
   DOW_Str = "Mon"
  Case 3
   DOW_Str = "Tue"
  Case 4
   DOW_Str = "Wed"
  Case 5
   DOW_Str = "Thu"
  Case 6
   DOW_Str = "Fri"
  Case 7
   DOW_Str = "Sat" 
  Case Else
   DOW_Str = "Ukn"
End Select

Select Case Month
  Case 1
   Mon_Str = "Jan"
  Case 2
   Mon_Str = "Feb"
  Case 3
   Mon_Str = "Mar"
  Case 4
   Mon_Str = "Apr"
  Case 5
   Mon_Str = "May"
  Case 6
   Mon_Str = "Jun"
  Case 7
   Mon_Str = "Jul" 
  Case 8
   Mon_Str = "Aug"
  Case 9
   Mon_Str = "Sep"
  Case 10
   Mon_Str = "Oct"
  Case 11
   Mon_Str = "Nov"
  Case 12
   Mon_Str = "Dec"    
  Case Else
   Mon_Str = "Ukn"
End Select

If hour >= 12 and hour <= 23 then
am_pm = " PM"
Else
am_pm = " AM"
End If

If hour > 12 and hour <= 23 then
hour_str = cstr(hour - 12)
else
hour_Str = cstr(hour)
End if

If minute >= 0 and minute <= 9 then
min_str = "0" & cstr(minute)
Else
min_str = cstr(minute)
End if

Global_Local_Time = DOW_Str & " " & hour_str & ":" & min_str & am_pm
Global_Local_Date = Mon_Str & "/" & cstr(Day) & "/" & cstr(Year) 


'------------------------------------------------------------------------------------------
'Read ZBasic RTC Date/Time
Call GetTimestamp(Year, Month, Day, Hour, Minute, Seconds) 'Get ZBasic RTC
'-------------------------------------------------------------------------------------------

'Store time in ram
Call RamPoke(Hour, &H800)    'hour
Call RamPoke(Minute,&H801)   'min
Call RamPoke(Day, &H802)     'day
Call RamPoke(Month, &H803)   'month
Call RamPokeWord(Year,&H804) 'year


End Sub
'====================================================================================





